Loading...
Searching...
No Matches
Http_location

## Macros

#define | HTTP_LOCATION_INIT()
| Initializer for structure http_location_t.
#define | HTTPTAG_LOCATION(x)
| Tag list item for pointer to a Location header object.
#define | HTTPTAG_LOCATION_STR(s)
| Tag list item for string with Location header value.

## Typedefs

typedef struct http_location_s | http_location_t
| @HTTP_HEADER http_location Location Header

## Enumerations

enum | { http_location_hash }

## Functions

http_location_t * | http_location_init (http_location_t x[1])
| Initialize a structure http_location_t.
int | http_is_location (http_header_t const *header)
| Test if header object is instance of http_location_t.
http_location_t * | http_location_dup (su_home_t *home, http_location_t const *hdr))
| Duplicate (deep copy) `http_location_t`.
http_location_t * | http_location_copy (su_home_t *home, http_location_t const *hdr))
| Copy a http_location_t header structure.
http_location_t * | http_location_make (su_home_t *home, char const *s))
| Make a header structure http_location_t.
http_location_t * | http_location_format (su_home_t *home, char const *fmt,...)))
| Make a Location header from formatting result.

## Variables

msg_hclass_t | http_location_class []
| Header class for HTTP Location header.
msg_parse_f | http_location_d
| Decode (parse) a Location header.
msg_print_f | http_location_e
| Encode (print) a Location header.

## Detailed Description

## Macro Definition Documentation

## HTTP_LOCATION_INIT

#define HTTP_LOCATION_INIT | ( |  | ) |

Initializer for structure http_location_t.

A static http_location_t structure must be initialized with the HTTP_LOCATION_INIT() macro. For instance,

http_location_t http_location = HTTP_LOCATION_INIT;
http_location_t
struct http_location_s http_location_t
@HTTP_HEADER http_location Location Header
Definition http.h:135
HTTP_LOCATION_INIT
#define HTTP_LOCATION_INIT()
Initializer for structure http_location_t.
Definition http_protos.h:6342

## HTTPTAG_LOCATION

#define HTTPTAG_LOCATION | ( |  | x | ) |

Tag list item for pointer to a Location header object.

The HTTPTAG_LOCATION() macro is used to include a tag item with a pointer to a http_location_t object in a tag list.

Parameters

  x | pointer to a http_location_t header structure, or NULL.

## HTTPTAG_LOCATION_STR

#define HTTPTAG_LOCATION_STR | ( |  | s | ) |

Tag list item for string with Location header value.

The HTTPTAG_LOCATION_STR() macro is used to include a tag item with a string containing value of a http_location_t header in a tag list.

Parameters

  s | pointer to a string containing http_location_t value, or NULL.

The HTTPTAG_LOCATION_STR string can be converted to a http_location_t header structure by giving the string s has second argument to function http_location_make().

## Typedef Documentation

## http_location_t

typedef struct http_location_s http_location_t

@HTTP_HEADER http_location Location Header

The Location header is used to redirect the recipient to a location other than the Request-URI for completion of the request or identification of a new resource. Its syntax is defined in RFC 2616 section 14.30 as follows:

Location = "Location" ":" absoluteURI

The structure http_location_t contains representation of Location header.

The http_location_t is defined as follows:

typedef struct http_location_s
{
msg_common_t loc_common[1];
msg_error_t *loc_next;
url_t loc_url[1];
} http_location_t;
msg_error_t
struct msg_error_s msg_error_t
msg_common_t
struct msg_common_s msg_common_t
http_location_s
Location, Referer.
Definition http.h:242
url_t

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
http_location_hash | Hash of Location header.

## Function Documentation

## http_is_location()

int http_is_location | ( | http_header_t const * | header | ) |

inline

Test if header object is instance of http_location_t.

The function http_is_location() returns true (nonzero) if the header class is an instance of Location header object and false (zero) otherwise.

Parameters

  header | pointer to the header structure to be tested

Returns
  The function http_is_xlocation() returns true (nonzero) if the header object is an instance of header location and false (zero) otherwise.

## http_location_copy()

http_location_t * http_location_copy | ( | su_home_t * | home,
|  | http_location_t const * | hdr )

inline

Copy a http_location_t header structure.

The function http_location_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be duplicated

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old header, including the encoding of the old header, if present.

Example
  location = http_location_copy(home, http->http_location);
  http_location_copy
  http_location_t * http_location_copy(su_home_t *home, http_location_t const *hdr))
  Copy a http_location_t header structure.
  Definition http_protos.h:6536

Returns
  The function http_location_copy() returns a pointer to newly copied header structure, or NULL upon an error.

## http_location_dup()

http_location_t * http_location_dup | ( | su_home_t * | home,
|  | http_location_t const * | hdr )

inline

Duplicate (deep copy) `http_location_t`.

The function http_location_dup() duplicates a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  location = http_location_dup(home, http->http_location);
  http_location_dup
  http_location_t * http_location_dup(su_home_t *home, http_location_t const *hdr))
  Duplicate (deep copy) http_location_t.
  Definition http_protos.h:6529

Returns
  The function http_location_dup() returns a pointer to the newly duplicated http_location_t header structure, or NULL upon an error.

## http_location_format()

http_location_t * http_location_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Location header from formatting result.

The function http_location_format() makes a new Location header object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and uses the formatting result as the header value.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Note
  This function is usually implemented as a macro calling msg_header_format().

Returns
  The function http_location_format() returns a pointer to newly makes header structure, or NULL upon an error.

## http_location_init()

http_location_t * http_location_init | ( | http_location_t | x[1] | ) |

inline

Initialize a structure http_location_t.

An http_location_t structure can be initialized with the http_location_init() function/macro. For instance,

http_location_t http_location;
http_location_init(&http_location);
http_location_init
http_location_t * http_location_init(http_location_t x[1])
Initialize a structure http_location_t.
Definition http_protos.h:6358

## http_location_make()

http_location_t * http_location_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a header structure http_location_t.

The function http_location_make() makes a new http_location_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Note
  This function is usually implemented as a macro calling http_header_make().

Returns
  The function http_location_make() returns a pointer to newly maked http_location_t header structure, or NULL upon an error.

## Variable Documentation

## http_location_class

msg_hclass_t http_location_class[]

extern

Header class for HTTP Location header.

The header class http_location_class defines how a HTTP Location header is parsed and printed. It also contains methods used by HTTP parser and other functions to manipulate the http_location_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.